/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSKeyframeEffectReadOnly.h"

#include "JSCompositeOperation.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertObject.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMWrapperCache.h"
#include "JSElement.h"
#include "JSIterationCompositeOperation.h"
#include "JSKeyframeEffectOptions.h"
#include "JSKeyframeEffectReadOnly.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/ObjectConstructor.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> KeyframeEffectReadOnly::BasePropertyIndexedKeyframe convertDictionary<KeyframeEffectReadOnly::BasePropertyIndexedKeyframe>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    KeyframeEffectReadOnly::BasePropertyIndexedKeyframe result;
    JSValue compositeValue;
    if (isNullOrUndefined)
        compositeValue = jsUndefined();
    else {
        compositeValue = object->get(&state, Identifier::fromString(&state, "composite"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!compositeValue.isUndefined()) {
        result.composite = convert<IDLUnion<IDLNull, IDLSequence<IDLNullable<IDLEnumeration<CompositeOperation>>>, IDLEnumeration<CompositeOperation>>>(state, compositeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composite = Converter<IDLUnion<IDLNull, IDLSequence<IDLNullable<IDLEnumeration<CompositeOperation>>>, IDLEnumeration<CompositeOperation>>>::ReturnType{ };
    JSValue easingValue;
    if (isNullOrUndefined)
        easingValue = jsUndefined();
    else {
        easingValue = object->get(&state, Identifier::fromString(&state, "easing"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!easingValue.isUndefined()) {
        result.easing = convert<IDLUnion<IDLSequence<IDLDOMString>, IDLDOMString>>(state, easingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.easing = Converter<IDLUnion<IDLSequence<IDLDOMString>, IDLDOMString>>::ReturnType{ };
    JSValue offsetValue;
    if (isNullOrUndefined)
        offsetValue = jsUndefined();
    else {
        offsetValue = object->get(&state, Identifier::fromString(&state, "offset"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!offsetValue.isUndefined()) {
        result.offset = convert<IDLUnion<IDLNull, IDLSequence<IDLNullable<IDLDouble>>, IDLDouble>>(state, offsetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.offset = Converter<IDLUnion<IDLNull, IDLSequence<IDLNullable<IDLDouble>>, IDLDouble>>::ReturnType{ };
    return result;
}

template<> KeyframeEffectReadOnly::BaseKeyframe convertDictionary<KeyframeEffectReadOnly::BaseKeyframe>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    KeyframeEffectReadOnly::BaseKeyframe result;
    JSValue compositeValue;
    if (isNullOrUndefined)
        compositeValue = jsUndefined();
    else {
        compositeValue = object->get(&state, Identifier::fromString(&state, "composite"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!compositeValue.isUndefined()) {
        result.composite = convert<IDLNullable<IDLEnumeration<CompositeOperation>>>(state, compositeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composite = std::nullopt;
    JSValue easingValue;
    if (isNullOrUndefined)
        easingValue = jsUndefined();
    else {
        easingValue = object->get(&state, Identifier::fromString(&state, "easing"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!easingValue.isUndefined()) {
        result.easing = convert<IDLDOMString>(state, easingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.easing = "linear"_s;
    JSValue offsetValue;
    if (isNullOrUndefined)
        offsetValue = jsUndefined();
    else {
        offsetValue = object->get(&state, Identifier::fromString(&state, "offset"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!offsetValue.isUndefined()) {
        result.offset = convert<IDLNullable<IDLDouble>>(state, offsetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.offset = std::nullopt;
    return result;
}

template<> KeyframeEffectReadOnly::BaseComputedKeyframe convertDictionary<KeyframeEffectReadOnly::BaseComputedKeyframe>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    KeyframeEffectReadOnly::BaseComputedKeyframe result;
    JSValue compositeValue;
    if (isNullOrUndefined)
        compositeValue = jsUndefined();
    else {
        compositeValue = object->get(&state, Identifier::fromString(&state, "composite"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!compositeValue.isUndefined()) {
        result.composite = convert<IDLNullable<IDLEnumeration<CompositeOperation>>>(state, compositeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composite = std::nullopt;
    JSValue computedOffsetValue;
    if (isNullOrUndefined)
        computedOffsetValue = jsUndefined();
    else {
        computedOffsetValue = object->get(&state, Identifier::fromString(&state, "computedOffset"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!computedOffsetValue.isUndefined()) {
        result.computedOffset = convert<IDLDouble>(state, computedOffsetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue easingValue;
    if (isNullOrUndefined)
        easingValue = jsUndefined();
    else {
        easingValue = object->get(&state, Identifier::fromString(&state, "easing"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!easingValue.isUndefined()) {
        result.easing = convert<IDLDOMString>(state, easingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.easing = "linear"_s;
    JSValue offsetValue;
    if (isNullOrUndefined)
        offsetValue = jsUndefined();
    else {
        offsetValue = object->get(&state, Identifier::fromString(&state, "offset"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!offsetValue.isUndefined()) {
        result.offset = convert<IDLNullable<IDLDouble>>(state, offsetValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.offset = std::nullopt;
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const KeyframeEffectReadOnly::BaseComputedKeyframe& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto compositeValue = toJS<IDLNullable<IDLEnumeration<CompositeOperation>>>(state, dictionary.composite);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "composite"), compositeValue);
    if (!IDLDouble::isNullValue(dictionary.computedOffset)) {
        auto computedOffsetValue = toJS<IDLDouble>(IDLDouble::extractValueFromNullable(dictionary.computedOffset));
        result->putDirect(vm, JSC::Identifier::fromString(&vm, "computedOffset"), computedOffsetValue);
    }
    auto easingValue = toJS<IDLDOMString>(state, dictionary.easing);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "easing"), easingValue);
    auto offsetValue = toJS<IDLNullable<IDLDouble>>(dictionary.offset);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "offset"), offsetValue);
    return result;
}

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsKeyframeEffectReadOnlyPrototypeFunctionGetKeyframes(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsKeyframeEffectReadOnlyConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSKeyframeEffectReadOnlyConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsKeyframeEffectReadOnlyTarget(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsKeyframeEffectReadOnlyIterationComposite(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsKeyframeEffectReadOnlyComposite(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSKeyframeEffectReadOnlyPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSKeyframeEffectReadOnlyPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSKeyframeEffectReadOnlyPrototype* ptr = new (NotNull, JSC::allocateCell<JSKeyframeEffectReadOnlyPrototype>(vm.heap)) JSKeyframeEffectReadOnlyPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSKeyframeEffectReadOnlyPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSKeyframeEffectReadOnlyConstructor = JSDOMConstructor<JSKeyframeEffectReadOnly>;

static inline EncodedJSValue constructJSKeyframeEffectReadOnly1(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSKeyframeEffectReadOnlyConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    auto target = convert<IDLNullable<IDLInterface<Element>>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "target", "KeyframeEffectReadOnly", nullptr, "Element"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto keyframes = convert<IDLNullable<IDLObject>>(*state, state->uncheckedArgument(1));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto options = state->argument(2).isUndefined() ? std::optional<Converter<IDLUnion<IDLUnrestrictedDouble, IDLDictionary<KeyframeEffectOptions>>>::ReturnType>() : std::optional<Converter<IDLUnion<IDLUnrestrictedDouble, IDLDictionary<KeyframeEffectOptions>>>::ReturnType>(convert<IDLUnion<IDLUnrestrictedDouble, IDLDictionary<KeyframeEffectOptions>>>(*state, state->uncheckedArgument(2)));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = KeyframeEffectReadOnly::create(*state, WTFMove(target), WTFMove(keyframes), WTFMove(options));
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<KeyframeEffectReadOnly>>(*state, *castedThis->globalObject(), throwScope, WTFMove(object)));
}

static inline EncodedJSValue constructJSKeyframeEffectReadOnly2(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto* castedThis = jsCast<JSKeyframeEffectReadOnlyConstructor*>(state->jsCallee());
    ASSERT(castedThis);
    auto source = convert<IDLInterface<KeyframeEffectReadOnly>>(*state, state->uncheckedArgument(0), [](JSC::ExecState& state, JSC::ThrowScope& scope) { throwArgumentTypeError(state, scope, 0, "source", "KeyframeEffectReadOnly", nullptr, "KeyframeEffectReadOnly"); });
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = KeyframeEffectReadOnly::create(*state, *source);
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    return JSValue::encode(toJSNewlyCreated<IDLInterface<KeyframeEffectReadOnly>>(*state, *castedThis->globalObject(), throwScope, WTFMove(object)));
}

template<> EncodedJSValue JSC_HOST_CALL JSKeyframeEffectReadOnlyConstructor::construct(ExecState* state)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    size_t argsCount = std::min<size_t>(3, state->argumentCount());
    if (argsCount == 1) {
        return constructJSKeyframeEffectReadOnly2(state);
    }
    if (argsCount == 2) {
        return constructJSKeyframeEffectReadOnly1(state);
    }
    if (argsCount == 3) {
        return constructJSKeyframeEffectReadOnly1(state);
    }
    return argsCount < 1 ? throwVMError(state, throwScope, createNotEnoughArgumentsError(state)) : throwVMTypeError(state, throwScope);
}

template<> JSValue JSKeyframeEffectReadOnlyConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSAnimationEffectReadOnly::getConstructor(vm, &globalObject);
}

template<> void JSKeyframeEffectReadOnlyConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSKeyframeEffectReadOnly::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String("KeyframeEffectReadOnly"_s)), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(1), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSKeyframeEffectReadOnlyConstructor::s_info = { "KeyframeEffectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSKeyframeEffectReadOnlyConstructor) };

/* Hash table for prototype */

static const HashTableValue JSKeyframeEffectReadOnlyPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsKeyframeEffectReadOnlyConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSKeyframeEffectReadOnlyConstructor) } },
    { "target", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsKeyframeEffectReadOnlyTarget), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "iterationComposite", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsKeyframeEffectReadOnlyIterationComposite), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "composite", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsKeyframeEffectReadOnlyComposite), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "getKeyframes", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsKeyframeEffectReadOnlyPrototypeFunctionGetKeyframes), (intptr_t) (0) } },
};

const ClassInfo JSKeyframeEffectReadOnlyPrototype::s_info = { "KeyframeEffectReadOnlyPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSKeyframeEffectReadOnlyPrototype) };

void JSKeyframeEffectReadOnlyPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSKeyframeEffectReadOnly::info(), JSKeyframeEffectReadOnlyPrototypeTableValues, *this);
}

const ClassInfo JSKeyframeEffectReadOnly::s_info = { "KeyframeEffectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSKeyframeEffectReadOnly) };

JSKeyframeEffectReadOnly::JSKeyframeEffectReadOnly(Structure* structure, JSDOMGlobalObject& globalObject, Ref<KeyframeEffectReadOnly>&& impl)
    : JSAnimationEffectReadOnly(structure, globalObject, WTFMove(impl))
{
}

void JSKeyframeEffectReadOnly::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSKeyframeEffectReadOnly::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSKeyframeEffectReadOnlyPrototype::create(vm, &globalObject, JSKeyframeEffectReadOnlyPrototype::createStructure(vm, &globalObject, JSAnimationEffectReadOnly::prototype(vm, globalObject)));
}

JSObject* JSKeyframeEffectReadOnly::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSKeyframeEffectReadOnly>(vm, globalObject);
}

JSValue JSKeyframeEffectReadOnly::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSKeyframeEffectReadOnlyConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSKeyframeEffectReadOnly* IDLAttribute<JSKeyframeEffectReadOnly>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSKeyframeEffectReadOnly*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSKeyframeEffectReadOnly* IDLOperation<JSKeyframeEffectReadOnly>::cast(ExecState& state)
{
    return jsDynamicCast<JSKeyframeEffectReadOnly*>(state.vm(), state.thisValue());
}

EncodedJSValue jsKeyframeEffectReadOnlyConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSKeyframeEffectReadOnlyPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSKeyframeEffectReadOnly::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSKeyframeEffectReadOnlyConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSKeyframeEffectReadOnlyPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsKeyframeEffectReadOnlyTargetGetter(ExecState& state, JSKeyframeEffectReadOnly& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLNullable<IDLInterface<Element>>>(state, *thisObject.globalObject(), throwScope, impl.target());
    return result;
}

EncodedJSValue jsKeyframeEffectReadOnlyTarget(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSKeyframeEffectReadOnly>::get<jsKeyframeEffectReadOnlyTargetGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "target");
}

static inline JSValue jsKeyframeEffectReadOnlyIterationCompositeGetter(ExecState& state, JSKeyframeEffectReadOnly& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnumeration<IterationCompositeOperation>>(state, throwScope, impl.iterationComposite());
    return result;
}

EncodedJSValue jsKeyframeEffectReadOnlyIterationComposite(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSKeyframeEffectReadOnly>::get<jsKeyframeEffectReadOnlyIterationCompositeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "iterationComposite");
}

static inline JSValue jsKeyframeEffectReadOnlyCompositeGetter(ExecState& state, JSKeyframeEffectReadOnly& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLEnumeration<CompositeOperation>>(state, throwScope, impl.composite());
    return result;
}

EncodedJSValue jsKeyframeEffectReadOnlyComposite(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSKeyframeEffectReadOnly>::get<jsKeyframeEffectReadOnlyCompositeGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "composite");
}

static inline JSC::EncodedJSValue jsKeyframeEffectReadOnlyPrototypeFunctionGetKeyframesBody(JSC::ExecState* state, typename IDLOperation<JSKeyframeEffectReadOnly>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLSequence<IDLObject>>(*state, *castedThis->globalObject(), impl.getKeyframes(*state)));
}

EncodedJSValue JSC_HOST_CALL jsKeyframeEffectReadOnlyPrototypeFunctionGetKeyframes(ExecState* state)
{
    return IDLOperation<JSKeyframeEffectReadOnly>::call<jsKeyframeEffectReadOnlyPrototypeFunctionGetKeyframesBody>(*state, "getKeyframes");
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7KeyframeEffectReadOnly@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore22KeyframeEffectReadOnlyE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<KeyframeEffectReadOnly>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(__identifier("??_7KeyframeEffectReadOnly@WebCore@@6B@"));
#else
    void* expectedVTablePointer = WTF_PREPARE_VTBL_POINTER_FOR_INSPECTION(&_ZTVN7WebCore22KeyframeEffectReadOnlyE[2]);
#endif

    // If this fails KeyframeEffectReadOnly does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<KeyframeEffectReadOnly>::value, "KeyframeEffectReadOnly is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // KeyframeEffectReadOnly has subclasses. If KeyframeEffectReadOnly has subclasses that get passed
    // to toJS() we currently require KeyframeEffectReadOnly you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<KeyframeEffectReadOnly>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, KeyframeEffectReadOnly& impl)
{
    return wrap(state, globalObject, impl);
}

KeyframeEffectReadOnly* JSKeyframeEffectReadOnly::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSKeyframeEffectReadOnly*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
